/****************************************************************************
**
** Copyright (C) 1992-2004 Trolltech AS. All rights reserved.
**
** This file is part of the demonstration applications of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#ifndef COLORSWATCH_H
#define COLORSWATCH_H

#include <qdockwindow.h>

class QAction;
class QActionGroup;
class QMenu;

class ColorSwatch : public QDockWindow
{
    Q_OBJECT

    QAction *showHideAction;

    QAction *closableAction;
    QAction *movableAction;
    QAction *floatableAction;
    QAction *topLevelAction;

    QActionGroup *allowedAreasActions;
    QAction *allowLeftAction;
    QAction *allowRightAction;
    QAction *allowTopAction;
    QAction *allowBottomAction;

    QActionGroup *areaActions;
    QAction *leftAction;
    QAction *rightAction;
    QAction *topAction;
    QAction *bottomAction;

public:
    ColorSwatch(const QString & colorName, QMainWindow *parent, Qt::WFlags flags);

    QMenu *menu;

protected:
    virtual void contextMenuEvent(QContextMenuEvent *event);
    virtual void polishEvent(QEvent *);

    virtual void hideEvent(QHideEvent *);
    virtual void showEvent(QShowEvent *);

private:
    void allow(Qt::DockWindowArea area, bool allow);
    void place(Qt::DockWindowArea area, bool place);

private slots:
    void showHide();

    void changeClosable(bool on);
    void changeMovable(bool on);
    void changeFloatable(bool on);

    void changeTopLevel(bool topLevel);

    void allowLeft(bool a);
    void allowRight(bool a);
    void allowTop(bool a);
    void allowBottom(bool a);

    void placeLeft(bool p);
    void placeRight(bool p);
    void placeTop(bool p);
    void placeBottom(bool p);
};

#endif // COLORSWATCH_H
